use minify_html::{minify, Cfg};
use std::io::Read;

pub fn process<T: AsRef<std::path::Path> + ?Sized>(path: &T) -> Result<Vec<u8>, Box<dyn std::error::Error>> {
    let mut code = vec![];
    std::fs::File::open(path)?.read_to_end(&mut code)?;
    let cfg = Cfg {
        keep_comments: false,
        minify_js: true,
        minify_css: true,
        minify_css_level_1: true,
        minify_css_level_2: true,
        ..Default::default()
    };

    Ok(minify(&code, &cfg))
}
